Subject: Re: [RFC PATCH v5 01/16] RDMA/irdma: Add driver framework definitions

From: Jason Gunthorpe <[email-masked]>
Date: Thu, 23 Apr 2020 12:02:01 -0300

On Thu, Apr 23, 2020 at 12:32:48AM +0000, Saleem, Shiraz wrote:

> we have a split initialization design for gen2 and future products.
> phase1 is control path resource initialization in irdma_probe_dev
> and phase-2 is the rest of the resources with the ib registration
> at the end of irdma_open. irdma_close must de-register the ib device
> which will take care of ibdev free too. So it makes sense to keep
> allocation of the ib device in irdma_open.

The best driver pattern is to allocate the ib_device at the very start
of probe() and use this to anchor all the device resources and
memories.

The whole close/open thing is really weird, you should get rid of it.

Jason